Module Module1
    Private Const sConnection As String = "Provider=SQLOLEDB.1;" & _
                                          "Password=;" & _
                                          "Persist Security Info=True;" & _
                                          "User ID=sa;" & _
                                          "Initial Catalog=Pubs;" & _
                                          "Data Source=(local)"

    Sub Main()
        Dim sSQL As String
        sSQL = "SELECT * From Authors"

        Dim objConn As New OleDb.OleDbConnection(sConnection)
        Dim objDataAdapter As New OleDb.OleDbDataAdapter(sSQL, objConn)
        Dim objDS As New DataSet("Pubs")
        Dim objTable As DataTable
        Dim drRows As DataRowCollection
        Dim objRow As DataRow

        Dim objCmdBuilder As New OleDb.OleDbCommandBuilder(objDataAdapter)


        Try
            objConn.Open()
        Catch myException As System.Exception
            Console.WriteLine(myException.Message)
        End Try

        If objConn.State = ConnectionState.Open Then
            Try
                objDataAdapter.MissingSchemaAction = MissingSchemaAction.AddWithKey
                'objDataAdapter.FillSchema(objDS, SchemaType.Source, "Authors")

                objDataAdapter.Fill(objDS, "Authors")

                objTable = objDS.Tables("Authors")
                drRows = objTable.Rows




                objRow = drRows.Find("427-17-2319")

                objRow.BeginEdit()
                objRow("au_lname") = "Exciting"
                objRow.EndEdit()

                objDataAdapter.Update(objDS, "Authors")


            Catch myException As System.Exception
                Console.WriteLine(myException.Message)
            End Try
            Console.ReadLine()
        End If

    End Sub
    Sub DisplayTable(ByRef objTable As DataTable)
        Dim objRow As DataRow
        Dim objCol As DataColumn
        Dim i, j As Integer

        For j = 0 To objTable.Columns.Count - 1
            objCol = objTable.Columns(j)
            Console.Write("{0}:{1} ", objCol.ColumnName, objCol.DataType.Name)
        Next
        Console.WriteLine()

        For i = 0 To objTable.Rows.Count - 1
            objRow = objTable.Rows(i)
            For j = 0 To objTable.Columns.Count - 1
                Console.Write("{0} ", objRow.Item(j))
            Next
            Console.WriteLine()
        Next
    End Sub
End Module