Module Module1
    Private Const sConnection As String = "Provider=SQLOLEDB.1;" & _
                                          "Password=;" & _
                                          "Persist Security Info=True;" & _
                                          "User ID=sa;" & _
                                          "Initial Catalog=CD;" & _
                                          "Data Source=(local)"

    Sub Main()
        Dim sSQL As String
        sSQL = "SELECT Artist.ArtistID, " & _
               "Artist.ArtistName, Disc.CDTitle " & _
               "FROM Artist INNER JOIN Disc ON " & _
               "Artist.ArtistID = Disc.ArtistID;"

        Dim objConn As New OleDb.OleDbConnection(sConnection)
        Dim objDataAdapter As New OleDb.OleDbDataAdapter(sSQL, objConn)
        Dim objDS As New DataSet("CDs")

        Try
            objConn.Open()
        Catch myException As System.Exception
            Console.WriteLine(myException.Message)
        End Try

        If objConn.State = ConnectionState.Open Then
            Try
                objDataAdapter.Fill(objDS, "Disc")
                objConn.Close()
                Dim objTable As DataTable
                objTable = objDS.Tables("Disc")

                Dim objRow As DataRow
                For Each objRow In objTable.Rows
                    Console.WriteLine(objRow.Item("CDTitle"))
                Next

                Dim i As Integer
                For i = 0 To objTable.Rows.Count - 1
                    objRow = objTable.Rows(i)
                    Console.WriteLine(objRow.Item("CDTitle"))
                Next

                Dim objColumn As DataColumn

                For Each objColumn In objTable.Columns
                    Console.WriteLine("Column Name: {0} Data Type: {1}", _
                            objColumn.ColumnName, _
                            objColumn.DataType.FullName)
                Next

                Console.WriteLine("{0} Rows", objDS.Tables("Disc").Rows.Count)

            Catch myException As System.Exception
                Console.WriteLine(myException.Message)
            End Try
            Console.ReadLine()
        End If

    End Sub
End Module


