Module Module1
    Private Const sConnection As String = "Provider=SQLOLEDB.1;" & _
              "Password=;" & _
              "Persist Security Info=True;" & _
              "User ID=sa;" & _
              "Initial Catalog=CD;" & _
              "Data Source=(local)"

	Sub Main()
		Dim sSQL As String
		sSQL = "SELECT Artist.ArtistID, " & _
		"Artist.ArtistName, Disc.CDTitle " & _
		"FROM Artist INNER JOIN Disc ON " & _
		"Artist.ArtistID = Disc.ArtistID;"

		Dim objConn As New _
			OleDb.OleDbConnection(sConnection)
		Dim objDataAdapter As New _
			OleDb.OleDbDataAdapter(sSQL, objConn)
		Dim objDS As New _
			DataSet("CDs")

		Try
			objConn.Open()
		Catch myException As System.Exception
			Console.WriteLine(myException.Message)
		End Try

		If objConn.State = ConnectionState.Open Then
			Try
				objDataAdapter.Fill(objDS, "Disc")
				objConn.Close()
				Dim objTable As DataTable
				objTable = objDS.Tables("Disc")

				DisplayTable(objTable)

			Catch myException As System.Exception
				Console.WriteLine(myException.Message)
			End Try
			Console.ReadLine()
		End If

	End Sub

	Sub DisplayTable(ByRef objTable As DataTable)
		Dim objRow As DataRow
		Dim objCol As DataColumn
		Dim i, j As Integer

		For j = 0 To objTable.Columns.Count - 1
			objCol = objTable.Columns(j)
			Console.Write("{0}:{1} ", _
				objCol.ColumnName, _
				objCol.DataType.Name)
		Next
		Console.WriteLine()

		For i = 0 To objTable.Rows.Count - 1
			objRow = objTable.Rows(i)
			For j = 0 To objTable.Columns.Count - 1
				Console.Write("{0} ", objRow.Item(j))
			Next
			Console.WriteLine()
		Next
	End Sub
End Module