Option Explicit On 
Imports System
Imports Microsoft.VisualBasic.ControlChars

Module modMain

    Sub Main()

        Dim sInput As String
        Dim dblReturn As Double

        'Get User Input
        Dim dblPayment As Double
        Console.Write("Enter loan amount:")
        sInput = Console.ReadLine()
        dblReturn = CDbl(sInput)

        'Create the table
        OutputMortgageTable(dblReturn)
        Console.Write("Press ENTER to continue")
        Console.ReadLine()
    End Sub

    Private Sub OutputMortgageTable(ByVal Principal As Double)

        Dim iYears As Integer
        Dim iRate As Integer
        Dim dblAnnualInterest As Double

        Console.WriteLine(Tab & "Years" & Tab & "10" & Tab & "15" & _
            Tab & "20" & Tab & "25" & Tab & "30")
        Console.WriteLine("Interest")

        For iRate = 500 To 1000 Step 25
            dblAnnualInterest = iRate / 100

            For iYears = 10 To 30 Step 5
                Console.Write(Format(dblAnnualInterest, "0.#0") & Tab & Tab)
                'iYears * 12 to get the number of months (assumes monthly 
                'payments)
                Console.Write(Format(Payment(Principal, _
                    dblAnnualInterest, iYears * 12), "0.00") & Tab)
            Next
            Console.WriteLine()
        Next

    End Sub

    Public Function Payment(ByVal Principal As Double, _
             ByVal AnnualInterest As Double, _
             ByVal Periods As Integer) As Double
        Dim dblMonthlyInterest As Double = AnnualInterest / 1200
        Return Principal * dblMonthlyInterest * 1 + _
            dblMonthlyInterest ^ Periods / 1 + _
            dblMonthlyInterest ^ Periods - 1
    End Function

End Module
