<%@ Page Language="vb" AutoEventWireup="false" Codebehind="MadLib.aspx.vb" Inherits="Madlib.MadLib" %>
<HTML>
	<HEAD>
		<meta content="Microsoft Visual Studio.NET 7.0" name="GENERATOR">
		<meta content="Visual Basic 7.0" name="CODE_LANGUAGE">
	</HEAD>
	<body>
		<form id="WebForm1" method="post" runat="server">
			<p>
				<asp:image id="imgHead" runat="server" imageurl="madlib.gif"></asp:image>
			</p>
			<p>
				A Mad Lib is a game where one player selects a series of words (usually by type 
				of word, or a description). These words are then plugged into a story at 
				specific spots to create a (hopefully) amusing, personalized&nbsp;end result.
			</p>
			<p>
				<asp:Label id="lblName" runat="server" Font-Bold="True">Your first name:</asp:Label>
				<asp:TextBox id="txtName" runat="server"></asp:TextBox>
				&nbsp;&nbsp;
				<asp:Label id="lblDate" runat="server" Font-Bold="True">A date:</asp:Label>
				<asp:TextBox id="txtDate" runat="server"></asp:TextBox>
			</p>
			<p>
				<asp:Label id="lblFruit" runat="server" Font-Bold="True">A kind of fruit:</asp:Label>
				<asp:DropDownList id="cboFruit" runat="server" Width="163px" Height="22px">
					<asp:ListItem Value="Mango">Mango</asp:ListItem>
					<asp:ListItem Value="Orange">Orange</asp:ListItem>
					<asp:ListItem Value="Banana">Banana</asp:ListItem>
					<asp:ListItem Value="Currant">Currant</asp:ListItem>
					<asp:ListItem Value="Berry">Berry</asp:ListItem>
					<asp:ListItem Value="Kumquat">Kumquat</asp:ListItem>
					<asp:ListItem Value="Peach">Peach</asp:ListItem>
					<asp:ListItem Value="Kiwi">Kiwi</asp:ListItem>
					<asp:ListItem Value="Apricot">Apricot</asp:ListItem>
					<asp:ListItem Value="Plum">Plum</asp:ListItem>
				</asp:DropDownList>
				&nbsp;&nbsp;
				<asp:Label id="lblNumber" runat="server" Font-Bold="True">A number from 100 to 1000:</asp:Label>
				<asp:TextBox id="txtNumber" runat="server" Width="74" Height="24" MaxLength="4">500</asp:TextBox>
			</p>
			<p>
				<asp:Label id="lblEmotion" runat="server" Font-Bold="True">An emotional state:</asp:Label>
				<br>
				<asp:RadioButtonList id="rlstEmotion" runat="server" RepeatColumns="3">
					<asp:ListItem Value="Excited">Excited</asp:ListItem>
					<asp:ListItem Value="Frustrated">Frustrated</asp:ListItem>
					<asp:ListItem Value="Intrigued">Intrigued</asp:ListItem>
					<asp:ListItem Value="Saddened">Saddened</asp:ListItem>
					<asp:ListItem Value="Panicky">Panicky</asp:ListItem>
					<asp:ListItem Value="Ecstatic">Ecstatic</asp:ListItem>
					<asp:ListItem Value="Angry">Angry</asp:ListItem>
					<asp:ListItem Value="Jealous">Jealous</asp:ListItem>
					<asp:ListItem Value="Frightened">Frightened</asp:ListItem>
					<asp:ListItem Value="Happy">Happy</asp:ListItem>
					<asp:ListItem Value="Shocked">Shocked</asp:ListItem>
					<asp:ListItem Value="Blue">Blue</asp:ListItem>
				</asp:RadioButtonList>
			</p>
			<p>
				<asp:Label id="lblVerb" runat="server" Font-Bold="True">A verb:</asp:Label>
				<asp:TextBox id="txtVerb" runat="server"></asp:TextBox>
				&nbsp;&nbsp;
				<asp:Label id="lblOccupation" runat="server" Font-Bold="True">An occupation:</asp:Label>
				<asp:TextBox id="txtOccupation" runat="server"></asp:TextBox>
			</p>
			<p>
				<asp:Button id="cmdWrite" runat="server" Text="Write Story"></asp:Button>
				&nbsp;&nbsp;&nbsp;&nbsp;
				<asp:Button id="cmdClear" runat="server" Text="Clear"></asp:Button>
			</p>
			<p>
				<asp:Label id="lblResult" runat="server" Width="443" BorderStyle="Groove"></asp:Label>
			</p>
		</form>
	</body>
</HTML>
